![MisakaTranslator](https://github.com/hanmin0822/MisakaTranslator/blob/master/MisakaTranslator/Resources/Background.jpg)

<h1 align="center">
  MisakaTranslator
  <br>
</h1>

<p align="center">
  <b>Galgame's Multilingual Real-time Machine Translation Tool</b>
  <br>
  <b>Open Source | High Efficiency | Easy To Use</b>
  <br>
  <img src="https://github.com/hanmin0822/MisakaTranslator/workflows/CI/badge.svg" alt="CI">
  <br>
  <br>
</p>

<p align="center">
  <a href="/README.md">中文</a> •
  <a href="/README_EN.md">English</a>
</p>

~~MisakaTranslator's name comes from the animation "toaru Kagaku no railgun", The author hopes that this software can connect to 'MisakaNetwork' and obtain powerful functions~~


## Software Functions

* Good Compatibility: Support `hook + OCR` to extract game text, which can adapt to most games
* Offline: Support full offline work
* Extensible Text Repair: Provide multiple repair methods for repeated text extracted by hook
* Online API: Provide a variety of online APIs
* Higher OCR Accuracy: Support image preprocessing before submitting OCR
* Dictionaries: Support Mecab and search in dictionaries
* Translation Optimization System: Improve the quality of translation, this system is being continuously improved
* High Efficiency: High program efficiency
* Easy To Use: Friendly UI, easy to use
* More features are being made

## Help Author

If you are interested in this project and want to provide any help, please contact the author.

The author's contact information is below.

## Other Open Source Projects Used In This Project

* [~~IgnaceMaes/MaterialSkin~~](https://github.com/IgnaceMaes/MaterialSkin) 
* [~~MaterialSkin's fork~~](https://gitee.com/victorzhao/MaterialSkin)
* [~~kwwwvagaa/NetWinformControl~~](https://github.com/kwwwvagaa/NetWinformControl)
* [Artikash/Textractor](https://github.com/Artikash/Textractor)
* [JamesNK/Newtonsoft.Json](https://github.com/JamesNK/Newtonsoft.Json)
* [Config.Net](https://github.com/aloneguid/config)
* [charlesw/tesseract](https://github.com/charlesw/tesseract/)
* [tesseract-ocr/tesseract](https://github.com/tesseract-ocr/tesseract)
* [kekyo/MeCab.DotNet](https://github.com/kekyo/MeCab.DotNet)
* [HandyOrg/HandyControl](https://github.com/HandyOrg/HandyControl)
* [lgztx96/texthost](https://github.com/lgztx96/texthost)

## Important References Used In The Development Of The Project

* [C# calls various translation APIs and extract text using textractor](https://www.lgztx.com/) 
* [C# image processing](https://blog.csdn.net/chaoguodong/article/details/7877312)
* [C# uses the global keyboard and mouse hook](https://www.cnblogs.com/CJSTONE/p/4961865.html)

## Contact Author

E-Mail/QQ:512240272@qq.com

## Collaborator

* [unlsycn](https://github.com/HumphreyDotSln) 
* [tpxxn](https://github.com/tpxxn)

## MisakaProject

MisakaProject is a collection of all projects developed based on MisakaTranslator or its auxiliary functions.

If you are interested in adding your own projects of related types to MisakaProject, please contact the author.

* [jsc723/MisakaPatcher](https://github.com/jsc723/MisakaPatcher)

MisakaPatcher added support for plug-in Chinese patch, so this tool is more suitable for players who like manual translation, and also provides another way for Chinese personnel who have difficulty unpacking packets to release Chinese patch.

* [hanmin0822/MisakaHookFinder](https://github.com/hanmin0822/MisakaHookFinder)

MisakaHookFinder is suitable for some games where the translator can not be used to directly get the text hook method. Users can search for the hook special code by themselves or directly use it to get the source text. At the same time, it also supports the clipboard to output the original text.

## Project Team Members

* Character&Paintist-[百川行](https://www.pixiv.net/users/17591894)
* Paintist-[洛奚](https://www.pixiv.net/users/13495987)
* Web-[Disviel](https://github.com/Disviel)

## List Of Contributors

Thanks to all the people who have helped in the development of this project!

* Provide English translation of software-[Words](https://github.com/CPCer)
* Provide a lot of development help to the author-[lgztx96](https://github.com/lgztx96)
* [Click here to view the list of contributors](https://github.com/hanmin0822/MisakaTranslator/blob/master/THANKLIST.MD)

## Other Notes

Before 2.0 beta 3, MisakaTranslator need to call the CLI version of Textractor to read the output, but the original console output may cause the software to be unable to read. The changes to the CLI version are as follows. Please compile and use it by yourself.

* [hanmin0822/Textractor](https://github.com/hanmin0822/Textractor)

In the process of software development, some network materials are used. If your rights and interests are infringed, please contact the author to delete. Thank you!
